//======================================================================
//  cpiud048w.pas
//
//  Copyright (C) 2011 CPI Technologies,Inc.
//======================================================================
unit cpiud048w;

interface

uses
  Windows;

const
  //-----------------------------------------------------------------
  // 荞݃bZ[WID
  //-----------------------------------------------------------------
  WM_CHECK_TRG                  = $2000;  // bZ[WID

  //-----------------------------------------------------------------
  // G[R[h
  //-----------------------------------------------------------------
  D048_SUCCESS                  = 0;      // I
                                          // Windows G[
  D048_ERR_SYSTEM               = 1;      // GetLastError R[
  D048_ERR_NO_DEVICE            = 2;      // gp\ȃfoCXȂ
  D048_ERR_IN_USE               = 3;      // wfoCX͎gpł
  D048_ERR_INVALID_DEVICENO     = 4;      // Ș_foCXԍ
  D048_ERR_INVALID_ARGUMENT     = 5;      // Ȉ
  D048_ERR_INVALID_PORT         = 6;      // Ș_|[g
  D048_ERR_BAD_DIRECTION        = 7;      // sȕ
  D048_ERR_TRG_DATA_INVALID     = 8;      //  |[gĎvf[^Ȃ
  D048_ERR_DLL                  = DWord(not 0); // DLL [hs

  //-----------------------------------------------------------------
  // ̑
  //-----------------------------------------------------------------
  D048_MAX_DEVICES              = 16;
  D048_DEVICE_AUTO              = Word(not 0);

  //-----------------------------------------------------------------
  // tB^TCN̐ݒ
  //-----------------------------------------------------------------
  D048_FILTER_INTERVAL_STOP     = 0;
  D048_FILTER_INTERVAL_1260     = 1;
  D048_FILTER_INTERVAL_2520     = 2;
  D048_FILTER_INTERVAL_5040     = 3;
  D048_FILTER_INTERVAL_10080    = 4;
  D048_FILTER_INTERVAL_20160    = 5;

  //-----------------------------------------------------------------
  // |[gĎ̏
  //-----------------------------------------------------------------
  D048_MON_NODE                 = 0;      // Ȃ
  D048_MON_ALT                  = 1;      // Ώۃrbgɕω
  D048_MON_AND                  = 2;      // ΏۃrbgSv
  D048_MON_OR                   = 3;      // Ώۃrbgv

  //-----------------------------------------------------------------
  // EIb`hbNJE^̏
  //-----------------------------------------------------------------
  D048_WDT_FLAG_OFF             = 0;      // EIb`hbN܂́ANO
  D048_WDT_FLAG_ON              = 1;      // EIb`hbNN

  //-----------------------------------------------------------------
  // EIb`hbNJE^̐ݒ
  //-----------------------------------------------------------------
  D048_WDT_INTERVAL_STOP        = 0;
  D048_WDT_INTERVAL_126         = 1;
  D048_WDT_INTERVAL_252         = 2;
  D048_WDT_INTERVAL_504         = 3;
  D048_WDT_INTERVAL_1008        = 4;
  D048_WDT_INTERVAL_2016        = 5;

  //-----------------------------------------------------------------
  // jbg^Cv
  //-----------------------------------------------------------------
  D048_TYPE_TTL                 = 0;
  D048_TYPE_CMOS                = 1;

  //-----------------------------------------------------------------
  // _|[gԍ
  //-----------------------------------------------------------------
  D048_PORT_A                   = 0;
  D048_PORT_B                   = 1;
  D048_PORT_C                   = 2;
  D048_PORT_D                   = 3;
  D048_PORT_E                   = 4;
  D048_PORT_F                   = 5;
  D048_MAX_PORTS                = 6;      // |[g

  //-----------------------------------------------------------------
  // |[g
  //-----------------------------------------------------------------
  D048_DIR_A_OUTPUT             = $00;
  D048_DIR_A_INPUT              = $01;
  D048_DIR_B_OUTPUT             = $00;
  D048_DIR_B_INPUT              = $02;
  D048_DIR_C_OUTPUT             = $00;
  D048_DIR_C_INPUT              = $04;
  D048_DIR_D_OUTPUT             = $00;
  D048_DIR_D_INPUT              = $08;
  D048_DIR_E_OUTPUT             = $00;
  D048_DIR_E_INPUT              = $10;
  D048_DIR_F_OUTPUT             = $00;
  D048_DIR_F_INPUT              = $20;
  D048_DIR_ALL_OUTPUT           = (D048_DIR_A_OUTPUT
                                      or D048_DIR_B_OUTPUT
                                      or D048_DIR_C_OUTPUT
                                      or D048_DIR_D_OUTPUT
                                      or D048_DIR_E_OUTPUT
                                      or D048_DIR_F_OUTPUT
                                  );
  D048_DIR_ALL_INPUT            = (D048_DIR_A_INPUT
                                      or D048_DIR_B_INPUT
                                      or D048_DIR_C_INPUT
                                      or D048_DIR_D_INPUT
                                      or D048_DIR_E_INPUT
                                      or D048_DIR_F_INPUT
                                  );

  //-----------------------------------------------------------------
  // foCX
  //-----------------------------------------------------------------
const
  D048_CCH_VEN                  = 8;
  D048_CCH_DEV                  = 16;
  D048_CCH_VER                  = 4;

type
  SD048DI = record
    wCdb:   Word;                                   // bytes of command descriptor
    wSdb:   Word;                                   // bytes of status descriptor
    dwBuff: DWord;                                  // bytes of internal buffer
    sVen:   array [0 .. D048_CCH_VEN - 1] of Byte;  // vendor name
    sDev:   array [0 .. D048_CCH_DEV - 1] of Byte;  // device name
    sVer:   array [0 .. D048_CCH_VER - 1] of Byte;  // firmware version
  end;
  PD048DI = ^SD048DI;


type
  SD048PTRGCOND = record                      // |[gĎݒ̍\
    bMode:  Byte;                             // |[gĎ[h
    bMask:  Byte;                             // |[gĎ}XN
    bData:  Byte;                             // |[gĎf[^
  end;
  PD048PTRGCOND = ^SD048PTRGCOND;


//-------------------------------------------------------------------
// bp[
//-------------------------------------------------------------------
function UD048DllOpen: Boolean;
function UD048DllClose: Boolean;
function UD048GetLastError(wLogDevice: Word): DWord;
function UD048GetVersion(var pdwDllVersion: DWord; var pdwDriverVersion: DWord): Boolean;
function UD048Create(var pwLogDevice: Word; hwnd: THandle; uWMCode: Word): Boolean;
function UD048Close(wLogDevice: Word): Boolean;
function UD048GetDevInfo(wLogDevice: Word; pDevInfo: PD048DI): Boolean;
function UD048GetUnitType(wLogDevice: Word; var pdwType: Dword): Boolean;
function UD048GetSwitchValue(wLogDevice: Word; var pdwSwitchValue: DWord): Boolean;
function UD048GetDirections(wLogDevice: Word; var pdwDirections: Dword): Boolean;
function UD048SetDirections(wLogDevice: Word; dwDirections: Dword): Boolean;
function UD048InPort(wLogDevice: Word; dwLogPort: DWord; var pbInValue: Byte): Boolean;
function UD048OutPort(wLogDevice: Word; dwLogPort: DWord; bOutValue: Byte): Boolean;
function UD048SetWdt(wLogDevice: Word; bWdtValue: Byte): Boolean;
function UD048ResetWdt(wLogDevice: Word): Boolean;
function UD048SetDefaultOutput(wLogDevice: Word; dwLogPort: DWord; bDefaultValue: Byte): Boolean;
function UD048GetWdtStatus(wLogDevice: Word; var pbWdtStatus: Byte): Boolean;
function UD048SetTrgCond(wLogDevice: Word; dwLogPort: DWord; pTrgCond: PD048PTRGCOND): Boolean;
function UD048SetFilter(wLogDevice: Word; bInterval: Byte; bCount: Byte): Boolean;

const
  SZ_DLL = 'cpiud048.dll';  { DLL }

implementation

{$J+}	// ^t萔̕ύX\RpCw

const
  s_hDll: THandle = 0;      // DLLnh

//-------------------------------------------------------------------
// API
//-------------------------------------------------------------------
type
  TUD048GetLastError = function(wLogDevice: Word): DWord; stdcall;
  TUD048GetVersion = function(var pdwDllVersion: DWord; var pdwDriverVersion: DWord): Boolean; stdcall;
  TUD048Create = function(var pwLogDevice: Word; hwnd: Thandle; uWMCode: Word): Boolean; stdcall;
  TUD048Close = function(wLogDevice: Word): Boolean; stdcall;
  TUD048GetDevInfo = function(wLogDevice: Word; pDevInfo: PD048DI): Boolean; stdcall;
  TUD048GetUnitType = function(wLogDevice: Word; var pdwType: DWord): Boolean; stdcall;
  TUD048GetSwitchValue = function(wLogDevice: Word; var pdwSwitchValue: DWord): Boolean; stdcall;
  TUD048GetDirections = function(wLogDevice: Word; var pdwDirections: DWord): Boolean; stdcall;
  TUD048SetDirections = function(wLogDevice: Word; dwDirections: DWord): Boolean; stdcall;
  TUD048InPort = function(wLogDevice: Word; dwLogPort: DWord; var pbInValue: Byte): Boolean; stdcall;
  TUD048OutPort = function(wLogDevice: Word; dwLogPort: DWord; bOutValue: Byte): Boolean; stdcall;
  TUD048SetWdt = function(wLogDevice: Word; bWdtValue: Byte): Boolean; stdcall;
  TUD048ResetWdt = function(wLogDevice: Word): Boolean; stdcall;
  TUD048SetDefaultOutput = function(wLogDevice: Word; dwLogPort: Dword; bDefaultValue: Byte): Boolean; stdcall;
  TUD048GetWdtStatus = function(wLogDevice: Word; var pbWdtStatus: Byte): Boolean; stdcall;
  TUD048SetTrgCond = function(wLogDevice: Word; dwLogPort: Word; pTrgCond: PD048PTRGCOND): Boolean; stdcall;
  TUD048SetFilter = function(wLogDevice: Word; bInterval: Byte; bCount: Byte): Boolean; stdcall;
  TUD048_init = function(): Boolean; stdcall;
  TUD048_done = function(): Boolean; stdcall;



// DLLGNX|[g֐AhX̊i[ϐ
var
  pD048GetLastError: TUD048GetLastError;
  pD048GetVersion: TUD048GetVersion;
  pD048Create: TUD048Create;
  pD048Close: TUD048Close;
  pD048GetDevInfo: TUD048GetDevInfo;
  pD048GetUnitType: TUD048GetUnitType;
  pD048GetSwitchValue: TUD048GetSwitchValue;
  pD048GetDirections: TUD048GetDirections;
  pD048SetDirections: TUD048SetDirections;
  pD048InPort: TUD048InPort;
  pD048OutPort: TUD048OutPort;
  pD048SetWdt: TUD048SetWdt;
  pD048ResetWdt: TUD048ResetWdt;
  pD048SetDefaultOutput: TUD048SetDefaultOutput;
  pD048GetWdtStatus: TUD048GetWdtStatus;
  pD048SetTrgCond: TUD048SetTrgCond;
  pD048SetFilter: TUD048SetFilter;
  pD048_init: TUD048_init;
  pD048_done: TUD048_done;

  function det_get: Boolean;  forward;
  procedure det_inv; forward;

{$J-}

//======================================================================
//      DLL [h
//      
// ߂l    TRUE
//          s FALSE
//======================================================================
function UD048DllOpen: Boolean;
begin
  if 0 <> s_hDll then begin
    Result := True;       // [hς݂͐
    Exit;
  end;
  s_hDll := LoadLibrary(SZ_DLL);
  if 0 <> s_hDll then begin
    if det_get() = True then begin
      Result := True;
    end else begin
      UD048DllClose();
      Result := False;
    end;
  end else begin
    Result := False;
  end;
end;
//=====================================================================
//      DLL 
//      
// ߂l    TRUE
//          s FALSE
//=====================================================================
function UD048DllClose: Boolean;
begin
  if 0 = s_hDll then begin
    Result := True;           //Jς݂͐
  end else begin
    det_inv();
    if FreeLibrary(s_hDll) = False then begin
      Result := False;
    end else begin
      s_hDll := 0;
      Result := True;
    end;
  end;
end;
//======================================================================
//      ŌɔG[̃R[h擾
//      iDev    G[foCX̘_foCXԍ
// ߂l   G[R[h
//======================================================================
function UD048GetLastError(wLogDevice: Word): DWord;
begin
  if 0 = s_hDll then begin
    Result := D048_ERR_DLL;
  end else begin
    Result := pD048GetLastError(wLogDevice);
  end;
end;
//======================================================================
//    o[Wԍ擾
//    pdwDllVersion     DLL o[Wԍi[̈ւ̃|C^
//        pdwDriverVersion  hCoo[Wԍi[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048GetVersion(var pdwDllVersion: DWord; var pdwDriverVersion: Dword): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//======================================================================
//    foCX̎gp錾
//    pwLogDevice gpfoCX̘_foCXԍi[|C^
//        hwnd        |[gĎ@\gpꍇɃhCoo郁bZ[W󂯎
//                    EBhẼnhw肵܂B
//                    bZ[WgpȂꍇ NULL w肵܂B
//        uWMCode     |[gĎ@\gpꍇɑo郁bZ[W ID ̒lw肵܂B
//                    ʏ WM_USER (0x400) ȏ̒lw肵܂B
//                    bZ[WgpȂꍇ NULL w肵܂B
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048Create(var pwLogDevice: Word; hwnd: Thandle; uWMCode: Word): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048Create(pwLogDevice, hwnd, uWMCode);
end;
//======================================================================
//    gp̃foCX
//    wLogDevice  foCX̘_foCXԍ
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048Close(wLogDevice: Word): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048Close(wLogDevice);
end;
//======================================================================
//    foCX擾
//    wLogDevice  l擾_foCXԍ
//        pDevInfo    foCXi[\̂̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048GetDevInfo(wLogDevice: Word; pDevInfo: PD048DI): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048GetDevInfo(wLogDevice, pDevInfo);
end;
//======================================================================
//    jbg^Cv擾
//    wLogDevice  l擾foCX̘_foCXԍ
//        pdwType     ^Cvli[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048GetUnitType(wLogDevice: Word; var pdwType: DWord): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048GetUnitType(wLogDevice, pdwType);
end;
//======================================================================
//    jbgZNgXCb`̒l擾
//    wLogDevice      l擾foCX̘_foCXԍ
//        pdwSwitchValue  jbgZNgXCb`̒li[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048GetSwitchValue(wLogDevice: Word; var pdwSwitchValue: DWord): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048GetSwitchValue(wLogDevice, pdwSwitchValue);
end;
//======================================================================
//    擾
//    wLogDevice    ̏Ԃ擾foCX̘_foCXԍ
//        pdwDirections Ԃi[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048GetDirections(wLogDevice: Word; var pdwDirections: DWord): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048GetDirections(wLogDevice, pdwDirections);
end;
//======================================================================
//    ݒ
//    wLogDevice    ZbgfoCX̘_foCXԍ
//        dwDirections  Zbg̓e
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048SetDirections(wLogDevice: Word; dwDirections: DWord): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048SetDirections(wLogDevice, dwDirections);
end;
//======================================================================
//    Cӂ̃|[gf[^
//    wLogDevice  ͂foCX̘_foCXԍ
//        dwLogPort   ͂_|[g
//        pbInValue   ̓f[^i[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048InPort(wLogDevice: Word; dwLogPort: DWord; var pbInValue: Byte): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048InPort(wLogDevice, dwLogPort, pbInValue);
end;
//======================================================================
//    Cӂ̃|[gփf[^o
//    wLogDevice  o͂foCX̘_foCXԍ
//        dwLogPort   o͂_|[g
//        bOutValue   o͂f[^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048OutPort(wLogDevice: Word; dwLogPort: DWord; bOutValue: Byte): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048OutPort(wLogDevice, dwLogPort, bOutValue);
end;
//======================================================================
//    EIb`hbNJE^̐ݒ肨уEIb`hbN@\̊JnA~
//    wLogDevice  lݒ肷foCX̘_foCXԍ
//        bWdtValue   JE^l (0`5)
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048SetWdt(wLogDevice: Word; bWdtValue: Byte): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048SetWdt(wLogDevice, bWdtValue);
end;
//======================================================================
//    EIb`hbNJE^lɂ
//    wLogDevice  lݒ肷foCX̘_foCXԍ
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048ResetWdt(wLogDevice: Word): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048ResetWdt(wLogDevice);
end;
//======================================================================
//    EIb`hbNJE^oߌ̏o͂|[gђl̐ݒ
//    wLogDevice    lݒ肷foCX̘_foCXԍ
//        dwLogPort     o͂_|[g
//        bDefaultValue o͂f[^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048SetDefaultOutput(wLogDevice: Word; dwLogPort: DWord; bDefaultValue: Byte): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048SetDefaultOutput(wLogDevice, dwLogPort, bDefaultValue);
end;
//======================================================================
//    EIb`hbNJE^̏Ԃ擾
//    wLogDevice  l擾foCX̘_foCXԍ
//        pbWdtStatus EIb`hbNtOԂi[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048GetWdtStatus(wLogDevice: Word; var pbWdtStatus: Byte): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048GetWdtStatus(wLogDevice, pbWdtStatus);
end;
//======================================================================
//    |[gĎ̐ݒ
//    wLogDevice  lݒ肷foCX̘_foCXԍ
//        dwLogPort   Ď|[g̘_ԍw
//        pTrgCond    |[gĎli[̈ւ̃|C^
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048SetTrgCond(wLogDevice: Word; dwLogPort: DWord; pTrgCond: PD048PTRGCOND): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048SetTrgCond(wLogDevice, dwLogPort, pTrgCond);
end;
//======================================================================
//    tB^TCNAv񐔂̐ݒ
//    wLogDevice  lݒ肷foCX̘_foCXԍ
//        bInterval   tB^[TCNl (0`5)
//        bCount      v񐔁iCӁj
// ߂l  TRUE
//        s FALSE
//======================================================================
function UD048SetFilter(wLogDevice: Word; bInterval:Byte; bCount: Byte): Boolean;
begin
  Result := False;
  if s_hDll = 0 then Exit;
  Result := pD048SetFilter(wLogDevice, bInterval, bCount);
end;

//-------------------------------------------------------------------
//    DLLGNX|[g֐AhX̎擾
//    
// ߂l  True
//        s False
//-------------------------------------------------------------------
function det_get: Boolean;
begin
  Result := False;

  pD048GetLastError := GetProcAddress(s_hDll, 'D048GetLastError');
  if @pD048GetLastError = nil then Exit;
  pD048GetVersion := GetProcAddress(s_hDLL, 'D048GetVersion');
  if @pD048GetVersion = nil then Exit;
  pD048Create := GetProcAddress(s_hDLL, 'D048Create');
  if @pD048Create = nil then Exit;
  pD048Close := GetProcAddress(s_hDLL, 'D048Close');
  if @pD048Close = nil then Exit;
  pD048GetDevInfo := GetProcAddress(s_hDLL, 'D048GetDevInfo');
  if @pD048GetDevInfo = nil then Exit;
  pD048GetUnitType := GetProcAddress(s_hDLL, 'D048GetUnitType');
  if @pD048GetUnitType = nil then Exit;
  pD048GetSwitchValue := GetProcAddress(s_hDLL, 'D048GetSwitchValue');
  if @pD048GetSwitchValue = nil then Exit;
  pD048GetDirections := GetProcAddress(s_hDLL, 'D048GetDirections');
  if @pD048GetDirections = nil then Exit;
  pD048SetDirections := GetProcAddress(s_hDLL, 'D048SetDirections');
  if @pD048SetDirections = nil then Exit;
  pD048InPort := GetProcAddress(s_hDLL, 'D048InPort');
  if @pD048InPort = nil then Exit;
  pD048OutPort := GetProcAddress(s_hDLL, 'D048OutPort');
  if @pD048OutPort = nil then Exit;
  pD048SetWdt := GetProcAddress(s_hDLL, 'D048SetWdt');
  if @pD048SetWdt = nil then Exit;
  pD048ResetWdt := GetProcAddress(s_hDLL, 'D048ResetWdt');
  if @pD048ResetWdt = nil then Exit;
  pD048SetDefaultOutput := GetProcAddress(s_hDLL, 'D048SetDefaultOutput');
  if @pD048SetDefaultOutput = nil then Exit;
  pD048GetWdtStatus := GetProcAddress(s_hDLL, 'D048GetWdtStatus');
  if @pD048GetWdtStatus = nil then Exit;
  pD048SetTrgCond := GetProcAddress(s_hDLL, 'D048SetTrgCond');
  if @pD048SetTrgCond = nil then Exit;
  pD048SetFilter := GetProcAddress(s_hDLL, 'D048SetFilter');
  if @pD048SetFilter = nil then Exit;

  pD048_init := GetProcAddress(s_hDLL, 'd048_init');
  if @pD048_init = nil then Exit;
  pD048_done := GetProcAddress(s_hDLL, 'd048_done');
  if @pD048_done = nil then Exit;

  Result := pD048_init();
end;

//----------------------------------------------------------------------
//    Gg
//    
// ߂l  TRUE
//        s FALSE
//----------------------------------------------------------------------
procedure det_inv;
begin
  pD048_done();
end;


end.
