Attribute VB_Name = "DLLDef"
'***********************************************************************
' cpiud048.bas
'
' CPI-UD048 Windows API
'
' Copyright (C) CPI Technologies,Inc.
'***********************************************************************

'-----------------------------------------------------------------
' 荞݃bZ[WID
'-----------------------------------------------------------------
Global Const WM_CHECK_TRG = &H2000              ' bZ[WID

'-----------------------------------------------------------------
' G[R[h
'-----------------------------------------------------------------
Global Const D048_SUCCESS = 0                   ' I
                                                ' Windows G[
Global Const D048_ERR_SYSTEM = 1                ' GetLastError R[
Global Const D048_ERR_NO_DEVICE = 2             ' gp\ȃfoCXȂ
Global Const D048_ERR_IN_USE = 3                ' wfoCX͎gpł
Global Const D048_ERR_INVALID_DEVICENO = 4      ' Ș_foCXԍ
Global Const D048_ERR_INVALID_ARGUMENT = 5      ' Ȉ
Global Const D048_ERR_INVALID_PORT = 6          ' Ș_|[g
Global Const D048_ERR_BAD_DIRECTION = 7         ' sȕ
Global Const D048_ERR_TRG_DATA_INVALID = 8      ' |[gĎvf[^Ȃ
Global Const D048_ERR_DLL = -1                  ' DLL [hs

'-----------------------------------------------------------------
' ̑
'-----------------------------------------------------------------
Global Const D048_MAX_DEVICES = 16
Global Const D048_DEVICE_AUTO = -1

'-----------------------------------------------------------------
' tB^TCN̐ݒ
'-----------------------------------------------------------------
Global Const D048_FILTER_INTERVAL_STOP = 0
Global Const D048_FILTER_INTERVAL_1260 = 1
Global Const D048_FILTER_INTERVAL_2520 = 2
Global Const D048_FILTER_INTERVAL_5040 = 3
Global Const D048_FILTER_INTERVAL_10080 = 4
Global Const D048_FILTER_INTERVAL_20160 = 5

'-----------------------------------------------------------------
' |[gĎ̏
'-----------------------------------------------------------------
Global Const D048_MON_NODE = 0                  ' Ȃ
Global Const D048_MON_ALT = 1                   ' Ώۃrbgɕω
Global Const D048_MON_AND = 2                   ' ΏۃrbgSv
Global Const D048_MON_OR = 3                    ' Ώۃrbgv

'-----------------------------------------------------------------
' EIb`hbNJE^̏
'-----------------------------------------------------------------
Global Const D048_WDT_FLAG_OFF = 0              ' EIb`hbN܂́ANO
Global Const D048_WDT_FLAG_ON = 1               ' EIb`hbNN

'-----------------------------------------------------------------
' EIb`hbNJE^̐ݒ
'-----------------------------------------------------------------
Global Const D048_WDT_INTERVAL_STOP = 0
Global Const D048_WDT_INTERVAL_126 = 1
Global Const D048_WDT_INTERVAL_252 = 2
Global Const D048_WDT_INTERVAL_504 = 3
Global Const D048_WDT_INTERVAL_1008 = 4
Global Const D048_WDT_INTERVAL_2016 = 5

'-----------------------------------------------------------------
' jbg^Cv
'-----------------------------------------------------------------
Global Const D048_TYPE_TTL = 0
Global Const D048_TYPE_CMOS = 1

'-----------------------------------------------------------------
' _|[gԍ
'-----------------------------------------------------------------
Global Const D048_PORT_A = 0
Global Const D048_PORT_B = 1
Global Const D048_PORT_C = 2
Global Const D048_PORT_D = 3
Global Const D048_PORT_E = 4
Global Const D048_PORT_F = 5
Global Const D048_MAX_PORTS = 6                 ' |[g

'-----------------------------------------------------------------
' |[g
'-----------------------------------------------------------------
Global Const D048_DIR_A_OUTPUT = &H0
Global Const D048_DIR_A_INPUT = &H1
Global Const D048_DIR_B_OUTPUT = &H0
Global Const D048_DIR_B_INPUT = &H2
Global Const D048_DIR_C_OUTPUT = &H0
Global Const D048_DIR_C_INPUT = &H4
Global Const D048_DIR_D_OUTPUT = &H0
Global Const D048_DIR_D_INPUT = &H8
Global Const D048_DIR_E_OUTPUT = &H0
Global Const D048_DIR_E_INPUT = &H10
Global Const D048_DIR_F_OUTPUT = &H0
Global Const D048_DIR_F_INPUT = &H20
Global Const D048_DIR_ALL_OUTPUT = D048_DIR_A_OUTPUT _
                                        Or D048_DIR_B_OUTPUT _
                                        Or D048_DIR_C_OUTPUT _
                                        Or D048_DIR_D_OUTPUT _
                                        Or D048_DIR_E_OUTPUT _
                                        Or D048_DIR_F_OUTPUT
Global Const D048_DIR_ALL_INPUT = D048_DIR_A_INPUT _
                                        Or D048_DIR_B_INPUT _
                                        Or D048_DIR_C_INPUT _
                                        Or D048_DIR_D_INPUT _
                                        Or D048_DIR_E_INPUT _
                                        Or D048_DIR_F_INPUT

'-----------------------------------------------------------------
' foCX
'-----------------------------------------------------------------
Global Const D048_CCH_VEN = 8
Global Const D048_CCH_DEV = 16
Global Const D048_CCH_VER = 4

Type SD048DI
    wCdb As Integer                     ' bytes of command descriptor
    wSdb As Integer                     ' bytes of status descriptor
    dwBuff As Long                      ' bytes of internal buffer
    sVen(1 To D048_CCH_VEN) As Byte     ' vendor name
    sDev(1 To D048_CCH_DEV) As Byte     ' device name
    sVer(1 To D048_CCH_VER) As Byte     ' firmware version
End Type

Type SD048PTRGCOND                      ' |[gĎݒ̍\
    bMode As Byte                       ' |[gĎ[h
    bMask As Byte                       ' |[gĎ}XN
    bData As Byte                       ' |[gĎf[^
End Type


'-----------------------------------------------------------------
' APIGg
'-----------------------------------------------------------------
Public Declare Function D048GetLastError Lib "cpiud048" (ByVal wLogDevice As Integer) As Long
Public Declare Function D048GetVersion Lib "cpiud048" (ByRef pdwDllVersion As Long, ByRef pdwDriverVersion As Long) As Long
Public Declare Function D048Create Lib "cpiud048" (ByRef pwLogDevice As Integer, ByVal hwnd As Long, ByVal uWMCode As Integer) As Long
Public Declare Function D048Close Lib "cpiud048" (ByVal wLogDevice As Integer) As Long
Public Declare Function D048GetDevInfo Lib "cpiud048" (ByVal wLogDevice As Integer, ByRef pDevInfo As SD048DI) As Long
Public Declare Function D048GetUnitType Lib "cpiud048" (ByVal wLogDevice As Integer, ByRef pdwType As Long) As Long
Public Declare Function D048GetSwitchValue Lib "cpiud048" (ByVal wLogDevice As Integer, ByRef pdwSwitchValue As Long) As Long
Public Declare Function D048GetDirections Lib "cpiud048" (ByVal wLogDevice As Integer, ByRef pdwDirections As Long) As Long
Public Declare Function D048SetDirections Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal dwDirections As Long) As Long
Public Declare Function D048InPort Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal dwLogPort As Long, ByRef pbInValue As Byte) As Long
Public Declare Function D048OutPort Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Long
Public Declare Function D048SetWdt Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal bWdtValue As Byte) As Long
Public Declare Function D048ResetWdt Lib "cpiud048" (ByVal wLogDevice As Integer) As Long
Public Declare Function D048SetDefaultOutput Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal dwLogPort As Long, ByVal bDefaultValue As Byte) As Long
Public Declare Function D048GetWdtStatus Lib "cpiud048" (ByVal wLogDevice As Integer, ByRef pbWdtStatus As Byte) As Long
Public Declare Function D048SetTrgCond Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal dwLogPort As Long, ByRef pTrgCond As SD048PTRGCOND) As Long
Public Declare Function D048SetFilter Lib "cpiud048" (ByVal wLogDevice As Integer, ByVal bInterval As Byte, ByVal bCount As Byte) As Long
Public Declare Function d048_done Lib "cpiud048" () As Long
Public Declare Function d048_init Lib "cpiud048" () As Long


